// NumberPlate.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <windows.h>
#include "NumberPlate.h"
#include "numberplateclass.hpp"

#define MAX_LOADSTRING 100
static const int GLID_SIZE = 24;

// O[oϐ :
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

// ̃R[h W[Ɋ܂܂֐̐錾]܂ :
ATOM MyRegisterClass(HINSTANCE hInstance);
BOOL InitInstance(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK About(HWND, UINT, WPARAM, LPARAM);
NumberPlateClass* NumberPlate;
bool InitFlag = false;
bool ClearFlag = true;
HWND hWnd;
int CursorX;
int CursorY;

void Game_Initalize( void );
bool Game_Update( void );
bool SetNumber( int x, int y, int number );

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_NUMBERPLATE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂B:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_NUMBERPLATE);

	srand( ( unsigned int )time( NULL ) );

	NumberPlate = new NumberPlateClass;
	NumberPlate->CreateQuestion( 3, 3 );
	Game_Initalize();
	InitFlag = true;

	// C bZ[W [v :
	for( ; ; )
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( FALSE == GetMessage( &msg, NULL, 0, 0 ) )
			{
				break;
			}
			if( FALSE == TranslateAccelerator( msg.hwnd, hAccelTable, &msg ) )
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
		}
		else
		{
			if( false == Game_Update() )
			{
				break;
			}
		}
	}
	return (int) msg.wParam;
}



//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg :
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//     Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ 
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_NUMBERPLATE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_NUMBERPLATE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   ֐ : InitInstance(HANDLE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg :
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	int window_width;
	int window_height;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

	// EChȆ傫␳
    window_width = 218;
    window_height = 218;
	window_width += ( GetSystemMetrics( SM_CXSIZEFRAME ) * 2 );
	window_height += ( GetSystemMetrics( SM_CYSIZEFRAME ) * 2 + GetSystemMetrics( SM_CYMENU ) + GetSystemMetrics( SM_CYCAPTION ) );

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, CW_USEDEFAULT, window_width, window_height, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  ֐ : WndProc(HWND, unsigned, WORD, LONG)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Iꂽj[̉ :
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case ID_RESTART:
			NumberPlate->CreateQuestion( 3, 3 );
			ClearFlag = true;
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		if( false == InitFlag )
		{
			break;
		}
		// Clear
		if( true == ClearFlag )
		{
			Rectangle( hdc, 0, 0, 3 * GLID_SIZE * 3 + 1, 3 * GLID_SIZE * 3 );
			ClearFlag = false;
		}
		int i;
		int x;
		int y;
		// Glid
		for( i = 0; i < 10; i ++ )
		{
			MoveToEx( hdc, i * GLID_SIZE, 0, NULL );
			LineTo( hdc, i * GLID_SIZE, GLID_SIZE * 9 );
			MoveToEx( hdc, 0, i * GLID_SIZE, NULL );
			LineTo( hdc, GLID_SIZE * 9, i * GLID_SIZE );
		}
		for( i = 0; i < 4; i ++ )
		{
			MoveToEx( hdc, i * GLID_SIZE * 3, 0, NULL );
			LineTo( hdc, i * GLID_SIZE * 3, GLID_SIZE * 9 + 1 );
			MoveToEx( hdc, i * GLID_SIZE * 3 + 1, 0, NULL );
			LineTo( hdc, i * GLID_SIZE * 3 + 1, GLID_SIZE * 9 + 1 );
			MoveToEx( hdc, 0, i * GLID_SIZE * 3, NULL );
			LineTo( hdc, GLID_SIZE * 9 + 1, i * GLID_SIZE * 3 );
			MoveToEx( hdc, 0, i * GLID_SIZE * 3 + 1, NULL );
			LineTo( hdc, GLID_SIZE * 9 + 1, i * GLID_SIZE * 3 + 1 );
		}
		// Number
		for( y = 0; y < 9; y ++ )
		{
			for( x = 0; x < 9; x ++ )
			{
				int number;
				number = NumberPlate->GetNumber( x, y );
				if( 0 != number )
				{
					char number_string[ 16 ];
					sprintf( number_string, "%d", number );
					if( true == NumberPlate->GetChangeEnable( x, y ) )
					{
						if( ( true == NumberPlate->CheckVertical( x, y ) ) && ( true == NumberPlate->CheckHorizontal( x, y ) ) && ( true == NumberPlate->CheckGroup( x, y ) ) )
						{
							SetBkColor( hdc, RGB( 255, 255, 255 ) );
						}
						else
						{
							SetBkColor( hdc, RGB( 255, 0, 0 ) );
						}
					}
					else
					{
						SetBkColor( hdc, RGB( 200, 255, 255 ) );
					}
					TextOut( hdc, x * GLID_SIZE + 8, y * GLID_SIZE + 4, number_string, 1 );
				}
			}
		}
		// Cursor
		x = CursorX * GLID_SIZE + 3;
		y = CursorY * GLID_SIZE + 3;
		MoveToEx( hdc, x, y, NULL );
		LineTo( hdc, x + GLID_SIZE - 6, y );
		LineTo( hdc, x + GLID_SIZE - 6, y + GLID_SIZE - 6 );
		LineTo( hdc, x, y + GLID_SIZE - 6 );
		LineTo( hdc, x, y );
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_KEYDOWN:
		switch( wParam )
		{
			case 0x26:	// J[\L[ 
				CursorY --;
				if( 0 > CursorY )
				{
					CursorY = NumberPlate->GetHeight() - 1;
				}
				ClearFlag = true;
				break;
			case 0x27:	// J[\L[ E
				CursorX ++;
				if( NumberPlate->GetWidth() <= CursorX )
				{
					CursorX = 0;
				}
				ClearFlag = true;
				break;
			case 0x28:	// J[\L[ 
				CursorY ++;
				if( NumberPlate->GetHeight() <= CursorY )
				{
					CursorY = 0;
				}
				ClearFlag = true;
				break;
			case 0x25:	// J[\L[ 
				CursorX --;
				if( 0 > CursorX )
				{
					CursorX = NumberPlate->GetWidth() - 1;
				}
				ClearFlag = true;
				break;
			case '0':
			case 96:
				SetNumber( CursorX, CursorY, 0 );
				ClearFlag = true;
				break;
			case '1':
			case 97:
				SetNumber( CursorX, CursorY, 1 );
				ClearFlag = true;
				break;
			case '2':
			case 98:
				SetNumber( CursorX, CursorY, 2 );
				ClearFlag = true;
				break;
			case '3':
			case 99:
				SetNumber( CursorX, CursorY, 3 );
				ClearFlag = true;
				break;
			case '4':
			case 100:
				SetNumber( CursorX, CursorY, 4 );
				ClearFlag = true;
				break;
			case '5':
			case 101:
				SetNumber( CursorX, CursorY, 5 );
				ClearFlag = true;
				break;
			case '6':
			case 102:
				SetNumber( CursorX, CursorY, 6 );
				ClearFlag = true;
				break;
			case '7':
			case 103:
				SetNumber( CursorX, CursorY, 7 );
				ClearFlag = true;
				break;
			case '8':
			case 104:
				SetNumber( CursorX, CursorY, 8 );
				ClearFlag = true;
				break;
			case '9':
			case 105:
				SetNumber( CursorX, CursorY, 9 );
				ClearFlag = true;
				break;
		}
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

void Game_Initalize( void )
{
	CursorX = 0;
	CursorY = 0;
}

bool Game_Update( void )
{
	InvalidateRect( hWnd, NULL, FALSE );
	UpdateWindow( hWnd );
	if( true == NumberPlate->CheckClear() )
	{
		MessageBox( hWnd, "NA", "bZ[W", MB_OK );
		return false;
	}
	Sleep( 1 );
	return true;
}

bool SetNumber( int x, int y, int number )
{
	if( false == NumberPlate->GetChangeEnable( x, y ) )
	{
		return false;
	}
	NumberPlate->SetNumber( x, y, number );
	return true;
}
