#ifndef NUMBERPLATECLASS_HPP
#define NUMBERPLATECLASS_HPP

#include "plateclass.hpp"

class NumberPlateClass : public PlateClass
{
	public:
		NumberPlateClass( void );
		~NumberPlateClass( void );
		bool CreateQuestion( int width, int height );
		bool CheckClear( void );
		bool CheckVertical( int x, int y );
		bool CheckHorizontal( int x, int y );
		bool CheckGroup( int group_x, int group_y );
	private:
		// Private function
		NumberPlateClass( NumberPlateClass& numberplate );
		NumberPlateClass& operator = ( NumberPlateClass &numberplate );
};

#endif
