#ifndef PLATECLASS_HPP
#define PLATECLASS_HPP

class PlateClass
{
	public:
		PlateClass( void );
		~PlateClass( void );
		bool Create( int width, int height );
		void Release( void );
		int GetWidth( void );
		int GetHeight( void );
		int GetNumber( int x, int y );
		bool GetChangeEnable( int x, int y );
		bool SetNumber( int x, int y, int number );
		bool SetChangeEnable( int x, int y, bool enable );
	private:
		int* Plate;
		bool* ChangeEnable;
		int Width;
		int Height;
		// Private function
		PlateClass( PlateClass& plate );
		PlateClass& operator = ( PlateClass &plate );
};

#endif
